/* $Id: base.h,v 1.11 2004/07/27 13:17:13 baloo Exp $ */

#ifndef BASE_H
#define BASE_H

/* #include <assert.h> */

/* // IO */
#include <iostream>
/* #include <fstream> */
/* // STL */
/* #include <vector> */
/* #include <string> */
/* #include <list> */
/* #include <map> */
#include <GL/gl.h>
#include <SDL/SDL.h>

using namespace std;

// il faut mettre ces typedef avant le include tools.h parce que tools
// utilise UINT

typedef unsigned char  BYTE;
typedef unsigned short U16;
typedef unsigned long  U32;
typedef unsigned int   UINT; 

#include "tools.h"

/* the smaller this is, the more friction we have */
#define INERTIA 40
/* rotational inertia */
#define RINERTIA 1
/* Engine power */
#define POWER 0.03f
/* How fast we can turn */
#define RPOWER 0.1f
/* Gravity acceleration */
#define GRAVITY 0.04f
/* How long a car is allowed to roll on the floor, in milliseconds */
#define FLOORDL 3000

#define PI 3.141592653589793238
#define HALFPI 1.570796326794896619
#define TWOPI 6.283185307179586477

#define RADIANS *57.29577951308232088
/* sqrt(1/2) */
#define SQHALF 0.7071067811865475244
/* sqrt(1/3) */
#define SQTHIRD 0.5773502691896257645

/* Application */
#define APP_TITLE     ""
#define SCREEN_WIDTH  1200    // screen width pixels
#define SCREEN_HEIGHT  720    // screen height pixels
#define SCREEN_DEPTH    24    // bits per pixel

/* Misc */
#define FTOLERANCE    0.0001f

#endif // BASE_H
